﻿Procedure draw_box_lined(parent_canvas, value.f, units_text$, iconimg = -1, iconalpha = -1, frontcol = 0, bgcol = 0, fntcol = 0, pointcol = 0,barcol = 0, min.f = -50, max.f = 50, multi = 10)
  If StartVectorDrawing(CanvasVectorOutput(parent_canvas))
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetWidth(parent_canvas))
    VectorSourceColor(RGBA(255,255,255,255))   
    FillPath()   
    
    If frontcol = 0
      VectorSourceColor(RGBA(0, 0, 0, 255)) 
    Else
      VectorSourceColor(frontcol)
    EndIf
    AddPathBox(GadgetWidth(parent_canvas)/80,GadgetHeight(parent_canvas)/12,  GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/40), (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/6 ))
    StrokePath(GadgetWidth(parent_canvas)/60, #PB_Path_RoundCorner)
    AddPathBox(GadgetWidth(parent_canvas)/80,GadgetHeight(parent_canvas)/12,  GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/40), (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/6 ))
    FillPath()
    
    
    If bgcol = 0
      VectorSourceColor(RGBA(255, 255, 255, 255))
    Else
      VectorSourceColor(bgcol)
    EndIf 
    AddPathBox(GadgetWidth(parent_canvas)/3,GadgetHeight(parent_canvas)/8,  GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/3) - GadgetWidth(parent_canvas)/56, (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/4))
    StrokePath(GadgetWidth(parent_canvas)/60, #PB_Path_RoundCorner)
    AddPathBox(GadgetWidth(parent_canvas)/3,GadgetHeight(parent_canvas)/8,  GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/3) - GadgetWidth(parent_canvas)/56, (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/4))
    FillPath()   
    
    If barcol = 0
      VectorSourceColor(RGBA(0, 0, 0, 255))
    Else
      VectorSourceColor(barcol)
    EndIf 
    
    count = max - min
    
    VectorFont(FontID(0), GadgetWidth(parent_canvas)/50)   
    width.f = (GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/40) - (GadgetWidth(parent_canvas) - (GadgetWidth(parent_canvas)/3) - GadgetWidth(parent_canvas)/56))*2
    offset.f = (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/4) / 10
    y.f = GadgetHeight(parent_canvas)/8 - GadgetHeight(parent_canvas)/9 + offset
    x.f = GadgetWidth(parent_canvas)/3 + (2*offset)
    width.f = width- (4 * offset)
    space.f = width / count
    
    
    For i = 0 To count 
      If i%multi = 0
        MovePathCursor(x + (i *space),y + (3 * offset));,#PB_Path_Relative
        AddPathLine(x + (i *space) , (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/2)) 
        text$ = Str(i+min)
        MovePathCursor((x + (i *space))- VectorTextWidth(text$)/2,y + (2 * offset/3));,#PB_Path_Relative
        DrawVectorText(text$)
      Else
        MovePathCursor(x + (i *space),y + (4 *offset));,#PB_Path_Relative
        AddPathLine(x + (i *space) , (GadgetHeight(parent_canvas) - GadgetHeight(parent_canvas)/2)) 
      EndIf 
      StrokePath(space/4);
    Next 
    
    If pointcol = 0
      VectorSourceColor(RGBA(0, 0, 0, 255))
    Else
      VectorSourceColor(pointcol)
    EndIf
    
    
    scale_width.f = max - min
    MovePathCursor(x+(width/scale_width)*(value + Abs(min)),GadgetHeight(parent_canvas)/2 - offset)
    AddPathLine(-GadgetHeight(parent_canvas)/8, GadgetHeight(parent_canvas)/2.3 , #PB_Path_Relative)
    AddPathLine(GadgetHeight(parent_canvas)/4, 0, #PB_Path_Relative)
    AddPathLine(-GadgetHeight(parent_canvas)/8, -GadgetHeight(parent_canvas)/2.3, #PB_Path_Relative)
    FillPath()
    
    If iconalpha = -1 
      Color32.q = fntcol
      Color32 = Color32 & $FFFFFFFF 
      iconalpha = Alpha(Color32)
    EndIf
    
    If iconimg = - 1
      MovePathCursor(GadgetHeight(parent_canvas)/8, GadgetHeight(parent_canvas) /2 - GadgetHeight(parent_canvas) /4)
    Else
      MovePathCursor(GadgetHeight(parent_canvas)/8, GadgetHeight(parent_canvas) /2 - GadgetHeight(parent_canvas) /4)
      DrawVectorImage(ImageID(iconimg), iconalpha, GadgetHeight(parent_canvas)/2, GadgetHeight(parent_canvas)/2)
    EndIf
    
    If fntcol = 0
      VectorSourceColor(RGBA(255, 255, 255, 255))
    Else
      VectorSourceColor(fntcol)
    EndIf
    VectorFont(FontID(0), GadgetWidth(parent_canvas)/40)
    MovePathCursor(GadgetWidth(parent_canvas)/3.8,(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(text$)/2));
    DrawVectorText(units_text$)
    
    VectorFont(FontID(0), GadgetWidth(parent_canvas)/18)
    MovePathCursor(GadgetWidth(parent_canvas)/3.9 - VectorTextWidth(StrF(value,1)),(GadgetHeight(parent_canvas)/2) - (VectorTextHeight(text$)/2));
    DrawVectorText(StrF(value,1))
    
    StopVectorDrawing()
  EndIf
EndProcedure

UsePNGImageDecoder()
LoadImage(0, #PB_Compiler_FilePath  + "/icons/weather.png")
LoadImage(1, #PB_Compiler_FilePath  + "/icons/rpm.png")
LoadImage(2, #PB_Compiler_FilePath  + "/icons/humidity.png")

If OpenWindow(0, 0, 0, 480, 240, "Horizontal AD Gauge", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  AddWindowTimer(0, 123, 500)
  LoadFont(0, "Verdana", 11,  #PB_Font_HighQuality)
  
  CanvasGadget(10, 0, 0, WindowWidth(0), WindowHeight(0)/4)
  CanvasGadget(11, 0, 60, WindowWidth(0), WindowHeight(0)/4)
  CanvasGadget(12, 0, 120, WindowWidth(0), WindowHeight(0)/4)
  CanvasGadget(13, 0, 180, WindowWidth(0), WindowHeight(0)/4)
  Repeat
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      
      draw_box_lined(10,(Random(1000,0)-500)/10,"°C")
      draw_box_lined(11,(Random(600,0)-200)/10,"°C",0,150,RGBA(124,37,41,255),RGBA(255,255,255,255),RGBA(255,255,255,150),RGBA(0,0,0,200),RGBA(0,0,0,255),-20,40,5)
      draw_box_lined(12,Random(150,0),"rpm",1,150,RGBA(229,158,109,255),RGBA(240,235,210,255),RGBA(0,0,0,150),RGBA(0,0,0,200),RGBA(0,0,0,255),0,150,50)
      draw_box_lined(13,Random(1000,0)/10,"%",2,50,RGBA(20,20,20,255),RGBA(20,20,20,255),RGBA(68,214,44,255),RGBA(68,214,44,255),RGBA(68,214,44,255),0,100,10)

    EndIf
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.72 (Linux - x64)
; CursorPosition = 122
; FirstLine = 97
; Folding = -
; EnableXP